/* header for options.c */

// note3 from shade.c: throughout the source, the terms 'options', 'switches', and 'parameters' are used interchangably

#ifndef SHADEHEADERS__OPTIONS_H
#define SHADEHEADERS__OPTIONS_H 1

#define NUM_OPTS (24)

#include "./types.h"

typedef struct{
  char   *opt;   /* the switch */
  char ***arg;   /* the arguments */
  int    *index; /* corresponding to VALID_OPTION */
  uint    cnt;   /* how many options */
}OPTION;

typedef struct{
  char opt[NUM_OPTS];   /* the switch */
  int  args[NUM_OPTS];  /* number of arguments */
}VALID_OPTION;

void initValidOpts(void);             /** set up an array structure which holds all valid options and how many arguments they take **/
int getOpt(char opt);                 /** return the index of an option, or 0 if not found **/
void initOpts(int args, char **arg);  /** stuff options and supplied into 'options' struction**/
void freeOpts(void);                  /** free all variavles in 'options' structure **/

#endif /* SHADEHEADERS__OPTIONS_H */
