/* this is shade */

// note0: this program has only been tested on machines which have little-endian 8-bit bytes.
// note1: the way this program takes arguments needs to be elaborated.
// note2: this program assumes a bit's first bit is the one farthest right, and its 8th is farthest left (ie 87654321)
// note3: a switch is passed with arguments such that "-r" is a switch and "host" is an ARGUMENT when given "shade -r host"
// note4: we'll use the term "perform" to mean either to read or to write.
// note5: ruler for formatting output text:
/*--------------------this--is--a--ruler--80--chars--long---------------------*/

//fixme: last two bytes in output are not right... [is it a newline on this windows machine?]
//fixme: evaluate mode is 4 bytes under. [better than over...]
//fixme: output in write mode is 1 byte under [did this fix itself?]
//fixme: -u is all fucked up

//addme: perform on bytes larger than 8 bits.

//tryme: bigendian bytes.

#include <stdio.h>
#include <stdlib.h>     /* atoi() malloc() */
#include <string.h>     /* strlen() strcpy() strcmp() */

#include "./types.h"
#include "./files.h"
#include "./strint.h"
#include "./bits.h"
#include "./options.h"
#include "./shade.h"

FILE *host=NULL, *payload=NULL,  /* used in main(), endProgram() */
     *out=NULL;                  /* used in main(), write(), endProgram() */
bool print_chars=true;           /* used in write(), main() */
int chartype=0;                  /* used in main(), write() */

int main(int args, char *arg[])
{
  uchar  hostByte=0, payByte=0, mode=0;
  uint   head=0, tail=0, len=0, i=0, c=0,
         h_processed=0, h=0, // host byte position (which bit)
         p_processed=0, p=0, // payload byte position (which bit)
         bits_processed=0,
         bits_per_byte=1;
  int    h_to_process=-1, //if it were 0, it would perform none. -1 reads all.
         p_to_process=-1,
         opt_index=-1, skip=0, r=0, toread=0, redund=0;
  bool   bigendian=false, exhibit=false, keepends=false, write_skip=false;

  extern FILE *host, *payload, *out;
  extern OPTION options;
  extern bool print_chars;
  extern int chartype;

  setbuf(stdout, NULL);

  if (args < 3) /* `shade -e host` min. args req. */
  {         /*--------------------this--is--a--ruler--80--chars--long---------------------*/
    printf("Shade - Steganographically Hide and Analyze Data Entries                       \n");
    printf(" version 1.1.0                                                                 \n");
    printf("                                                                               \n");
    printf(" You must supply an operation mode and a host file.                            \n");
    printf(" In write mode, you must supply a payload file.                                \n");
    printf(" Currently, Only 8-bit bytes are suppored.                                     \n");
    printf("                                                                               \n");
    printf(" Operation Modes:                                                              \n");
    printf("                                                                               \n");
    printf("  -r HOSTFILE   read       Read mode; Interrogate/Extract payload from host.   \n");
    printf("  -w HOSTFILE   write      Write mode; Inject payload into host.               \n");
    printf("  -e HOSTFILE   evaluate   Evaluate mode; Determine size limit of host.        \n");
    printf("                                                                               \n");
    printf(" Options:                                                                      \n");
    printf("                                                                               \n");
    printf("  -p PAYFILE    payload    Specify a payload file.                             \n");
    printf("  -o OUTFILE    output     Output processed data to file.                      \n");
    printf("  -l BYTES      length     Limit length of payload to process.                 \n");
    printf("  -b BITS       bits       Specify how many bits-per-byte to use in host.      \n");
    printf("  -B BYTES      bytes      Limit number of bytes in host to process.           \n");
//    printf("  -u TIMES      redundant  Write each payload bit multiple times consecutively.\n");
//    printf("                           In read mode, this option is applied to the '-s'    \n");
//    printf("                           option, whether or not it is supplied.              \n");
    printf("  -s BYTES      skip       Skip host bytes after processing each one (including\n");
    printf("                           each byte with redundant bits via the '-u' option). \n");
    printf("  -h BYTES      head       Skip bytes at head of host.                         \n");
    printf("  -t BYTES      tail       Skip bytes at tail of host.                         \n");
    printf("  -m            messages   Suppress all messages.                              \n");
    printf("                                                                               \n");
    printf(" Read mode-Only Options:                                                       \n");
    printf("                                                                               \n");
    printf("  -S BYTES      skipproc   Same as option '-s', but output unprocessed bytes.  \n");
    printf("  -c            charonly   Don't print non-printing characters.                \n");
    printf("  -C            charsub    Substitute non-printing characters with spaces      \n");
    printf("  -y            bianry     Output 1's and 0's instead of chars.                \n");
    printf("  -k            keep       Output head and tail data of host which is skipped  \n");
    printf("                           with options '-h' and/or '-t'.                      \n");
    printf("  -x            exhibit    Each byte is rounded by its LSB to 255 or 0. Options\n");
    printf("                           '-k -b 8' are implied. This may result in hidden    \n");
    printf("                           data in an image becoming obvious via the output    \n");
    printf("                           image (at least in sqequential bitmaps).            \n");
    printf("                                                                               \n");
    printf(" Extended Options:                                                             \n");
    printf("                                                                               \n");
    printf("  -E            bigendian  Perform on big-endian 8-bit bytes. (untested)       \n");
    printf("  -f TYPE       filetype   Perform using pre-defined options specific to       \n");
    printf("                           certain file formats.                               \n");
    printf("                                                                               \n");
    printf("     bmp8                  Windows 8-bit bitmap, 256 colors. (untested)        \n");
    printf("                           Presets: -h 1078                                    \n");
    printf("                           If option '-h' is supplied, it's argument will be   \n");
    printf("                           added to the preset value.                          \n");
    printf("                                                                               \n");
    printf("     bmp24                 Windows 24-bit bitmap, 16 million colors.           \n");
    printf("                           Presets: -h 75 -t 1                                 \n");
    printf("                           If option '-h' is supplied, it's argument will be   \n");
    printf("                           added to the preset value. If option '-t' is        \n");
    printf("                           supplied, it's argument will be added to the preset \n");
    printf("                           value.                                              \n");
    printf("                                                                               \n");
//  printf(" Unimplemented Functions:                                                      \n");
//  printf("                                                                               \n");
//  printf("  -X NUMBER   xor-crypt   Xor-crypt payload against repeating bit-sequence     \n");
//  printf("                          supplied in decimal form.                            \n");
//  printf("  -P PHRASE   phrase      Use a start-of/end-of data phrase in host.           \n");
//  printf("                                                                               \n");
    printf(" Bit Operations:                                                               \n");
    printf("                                                                               \n");
    printf("    These options are performed on every individual byte of payload. They can  \n");
    printf("  be supplied multiple times. Their order is crucial; for assurance of correct \n");
    printf("  payload extracction in read mode, these must be supplied in reverse order as \n");
    printf("  they were supplied in write mode.                                            \n");
    printf("                                                                               \n");
    printf("  -R BIT1 BIT2  reverse    Reverse order of bits from BIT1 to BIT2. Both must  \n");
    printf("                           be between 1 and 8. BIT2 must be larger than BIT1.  \n");
    printf("  -i BIT        invert     Invert a bit. Supplying this option on the same     \n");
    printf("                           bit multiple times will invert it accordingly.      \n");
    printf("  -T BIT1 BIT2  transpose  Transpose two bits. Both must be between 1 and 8.   \n");
    printf("                                                                               \n");
    return(0);
  }	

  /* Put options and arguments into 'options.opt[]' and 'options.arg[]' */
  initValidOpts();
  initOpts(args, arg);

  opt_index=getOpt('r');  /* read mode */
  if (opt_index != -1)
  {
    mode='r';

    host = fopen(options.arg[opt_index][0], "rb");

    if (host == NULL)
      endProgram(2);
  }

  opt_index=getOpt('w');  /* write mode */
  if (opt_index != -1)
  {
    if (mode != 0)
      endProgram(15);

    mode='w';

    host = fopen(options.arg[opt_index][0], "rb");

    if (host == NULL)
      endProgram(3);

    /* open the payload file */
    opt_index=getOpt('p');
    if (opt_index != -1)
    {
      payload = fopen(options.arg[opt_index][0], "rb");

      if (payload == NULL)
        endProgram(4);
    }else{
      /* payload was not supplied */
      endProgram(5);
    }
  }

  opt_index=getOpt('e');  /* check for evaluate mode */
  if (opt_index != -1)
  {
    if (mode != 0)
      endProgram(15);

    mode='e';
    host = fopen(options.arg[opt_index][0], "rb");

    if (host == NULL)
      endProgram(2);
  }

  if (mode == 0)
    endProgram(6);

  len=(filelen(host));

  opt_index=getOpt('o');  /* output to a file? */
  if (opt_index != -1)
  {
    out = fopen(options.arg[opt_index][0], "wb");

    if (out == NULL)
      endProgram(7);
  }
  
  opt_index=getOpt('b');  /* use [1-8] bits per host byte */
  if (opt_index != -1)
  {
    bits_per_byte=atoi(options.arg[opt_index][0]);
    if (bits_per_byte > 8 || bits_per_byte < 1)
      endProgram(8);
  }

  opt_index=getOpt('x');  /* exhibit mode */
  if (opt_index != -1)
  {
    if (mode == 'r')
    {
      exhibit=true;
      keepends=true; /* Option '-k' is implied */
      bits_per_byte = 8; /* Option '-b 8' is implied */
    }else{
      endProgram(18);
    }
  }
  
  opt_index=getOpt('k');  /* exhibit mode */
  if (opt_index != -1)
  {
    if (mode == 'r')
      keepends=true; /* Option '-k' is implied */
    else
      endProgram(20);
  }

  opt_index=getOpt('E');  /* big endian bytes */
  if (opt_index != -1)
    bigendian=true;
  
  opt_index=getOpt('c');  /* output only printable chars */
  if (opt_index != -1)
  {
    if (mode == 'r')
      chartype=1;
    else 
      endProgram(16);
  }

  opt_index=getOpt('C');  /* output non-printable chars as spaces */
  if (opt_index != -1)
  {
    if (mode =='r')
      chartype=2;
    else
      endProgram(17);
  }

  opt_index=getOpt('h');  /* skip bytes at head of host */
  if (opt_index != -1)
    head=atoi(options.arg[opt_index][0]);

  opt_index=getOpt('B');  /* process limited number of host bytes */
  if (opt_index != -1)
    h_to_process=atoi(options.arg[opt_index][0]);

  opt_index=getOpt('l');  /* process limited number of payload bytes */
  if (opt_index != -1)
    p_to_process=atoi(options.arg[opt_index][0]);

  opt_index=getOpt('y');  /* output bits instead of chars */
  if (opt_index != -1)
  {
    if (mode == 'r')
      print_chars=false;
    else
      endProgram(19);
  }

  opt_index=getOpt('f');  /* apply file presets */
  if (opt_index != -1)
  {
    if (!strcmp(options.arg[opt_index][0], "bmp8"))
    {
      head+=1078;
    }
    else if (!strcmp(options.arg[opt_index][0], "bmp24"))
    {
      head+=75;

      /* skip one byte at end of file */
      /* we want what ever is shorter: what was passed with -B, or where the tail begins that we're told not to write to by file presets */
      if (((len-head)-1) < h_to_process)
        h_to_process=((len-head)-1);
    }
  }

  opt_index=getOpt('t');  /* skip bytes at tail of host */
  if (opt_index != -1)
  {
    tail=atoi(options.arg[opt_index][0]);

    /* we want what ever is shorter: what was passed with -B or -f, or where the tail begins that we're told not to write to */
    if ((len-(head+tail)) < h_to_process)
      h_to_process=(len-(head+tail));
  }

  opt_index=getOpt('s');  /* skip bytes between host bytes */
  if (opt_index != -1)
    skip=atoi(options.arg[opt_index][0]);

  opt_index=getOpt('S');  /* skip bytes between host bytes, but write them */
  if (opt_index != -1)
  {
    if (mode == 'r')
    {
      skip=atoi(options.arg[opt_index][0]);
      write_skip=true;
    }else{
      endProgram(21);
    }
  }

//  opt_index=getOpt('u');  /* redundant bits */
//  if (opt_index != -1)
//  {
//    redund=atoi(options.arg[opt_index][0]);
//// this only worked with 1 bit per byte
////    if (mode != 'w')
////      skip=(skip*redund)+skip+redund;
//  }

  if (h_to_process < -1)  /* bytes to read must be positive, zero, or -1 */
    endProgram(12);

/** Cycle through and verify supplied bit operations **/
  for (i=1; i<options.cnt; i++)
  {
    if (options.opt[i] == 'R')  /* reverse bits */
    {
      /* make sure supplied arguments are valid */
      if (char2int(options.arg[i][0][0]) < 1 || //argument 1 must be between 1 and 8
          char2int(options.arg[i][0][0]) > 8 ||
          char2int(options.arg[i][1][0]) < 1 || //same for argument 2
          char2int(options.arg[i][1][0]) > 8 ||
          options.arg[i][1][0] < options.arg[i][0][0]
         )
        endProgram(9);
      continue;
    }

    if (options.opt[i] == 'i')  /* invert bits */
    {
      /* make sure supplied arguments are valid */
      for (c=0; c < strlen(options.arg[i][0]); c++)
        if (char2int(options.arg[i][0][c]) < 1 ||
            char2int(options.arg[i][0][c]) > 8)
          endProgram(10);
      continue;
    }

    if (options.opt[i] == 'T')  /* transpose bits */
    {
      /* make sure supplied arguments are valid */
      if( (char2int(options.arg[i][0][0]) < 1 ||
           char2int(options.arg[i][0][0]) > 8
          ) ||
          (char2int(options.arg[i][1][0]) < 1 ||
           char2int(options.arg[i][1][0]) > 8
          )
        )
        endProgram(11);
      continue;
    }
  }

/** WRITE MODE **********/
  if (mode == 'w')
  {
    /* skip host head bytes if we were asked to */
    for (; head > 0; head--)
    {
      if (read(host, &hostByte) == 0)
        endProgram(1);

      write(hostByte);  /* we need to output this even though we don't process it */
    }

    p=0;
    h=0;

    while(1)
    {
      if (h == 0)
      {
        for (toread=1+skip; toread>0; toread--)
        {
          if (h_processed == h_to_process)
            endProgram(13);

          if (read(host, &hostByte) == 0)
            endProgram(1);

          if (bigendian != 0)
            hostByte=reverseBits(hostByte, 1, 8);

          if (toread > 1)  /* if we skip this byte, write it */
          {
            if (h_processed == 0)  /* don't skip the first byte */
              break;

            write(hostByte);
            h_processed++;
          }
        }
        
        h=bits_per_byte; /* set up host bit position */
      }

      if (p == 0)
      {
        if (read(payload, &payByte) == 0 ||
            p_processed == p_to_process)
        {
          while (1)  /* output the rest of the host file */
          {
            if (read(host, &hostByte) == 0 ||
            h_processed == h_to_process)
              break;

            write(hostByte);
            h_processed++;
          }

          if (h_processed == h_to_process)
            endProgram(13);

          endProgram(0);
        }

        if (bigendian != 0)
          payByte=reverseBits(payByte, 1, 8);

        payByte=doBitManipFuncs(payByte);  /* do bit operations if supplied */
        p=8;  /* set up bit position */
        p_processed++;
      }
      
      /* change the bit in hostByte and move to the next bit positions */
      hostByte = putBit(hostByte, getBit(payByte, p), h);
      h--;
      p--;

      if (h == 0)  /* if we've finished this host byte */
      {
        if (bigendian != 0)
          hostByte=reverseBits(hostByte, 1, 8);

        write(hostByte);
        h_processed++;
      }

      if (redund > 0)
      {
        if (r == redund)
        {
          r=0;
        }else{
          p++; /* we'll need that last payload bit again */
          r++; /* one more redundant bit done */
        }
      }
    }
  }

/** READ MODE **********/
  if (mode == 'r')
  {
    /* skip host bytes if we were asked to */
    for (; head > 0; head--)
    {
      if (read(host, &hostByte) == 0)
        endProgram(1);
      if (keepends != 0)  /* only write header if we were asked to */
        write(hostByte);
    }

    p=8;
    h=0;
    r=0;

    while(1)
    {
      if (h <= 0)
      {
        for (toread=1+skip; toread>0; toread--)
        {
          if (h_processed == h_to_process)
          {
            if (keepends == 0)
            {
              endProgram(0);
            }else{
              while(read(host, &hostByte) != 0)  /* only write footer if we were asked to */
                write(hostByte);
            }
            endProgram(13);
          }

          if (p_processed == p_to_process)
            endProgram(0);

          if (read(host, &hostByte) == 0)
            endProgram(1);

          if (bigendian != 0)
            hostByte=reverseBits(hostByte, 1, 8);

          if (toread > 1)
          {
            if (h_processed == 0)  /* don't skip the first byte */
              break;

            h_processed++;

            if (write_skip != 0)  /* only output skipped bytes if we were asked to */
              write(hostByte);
          }
        }
        
        h=bits_per_byte; /* set up host bit position */
      }

      for (; r>0; r--) /* skip redundant bits if there are any */
      {
        if (h == 0)
          break; /* we need a new byte! */
        h--; /* next bit */
      }

      if (r == 0) /* if this isn't a redundant bit (or we just started) */
      {
        /* change the bit in payByte */
        payByte = putBit(payByte, getBit(hostByte, h), p);

        /* move to the next bit positions */
        h--;
        p--;

        if (h == 0)  /* if we've finished this host byte */
          h_processed++;

        /* reset the redundancy check for the next bit */
        r=redund;
      }

      if (p == 0)  /* if we've finished this pay byte */
      {
        payByte=doBitManipFuncs(payByte);  /* do bit operations if supplied */

        if (exhibit != 0)
        {
          if (getBit(payByte, 1) == 0)
            payByte=0; 
          else
            payByte=255;
        }

        if (bigendian != 0)
          payByte=reverseBits(payByte, 1, 8);

        write(payByte);
        p_processed++;
        p=8;
      }
    }
  }

/** EVALUATE MODE **********/
  else if (mode=='e')
  {
    r = filelen(host)-(head+tail); /* don't calculate head or tail bytes we skip */

    /* skipping bytes? */
    if (skip != 0)
      r /= (skip+1);
    
    r /= 8;  /* 8 bits in a byte */

    r *= bits_per_byte;
  
    printf("Host file can hold up to %i bytes using the supplied aguments.\n\n", r);
  }

  printf("WARNING: Quit without Signal.");
  endProgram(0);
  return 0; /* unneccesary, but it feels wrong not to keep this here */
}

/** Cycle through supplied options and perform sequential read/write methods **/
uchar doBitManipFuncs(uchar byte)
{
  uint i;

  extern OPTION options;

  for (i=0; i<options.cnt; i++)
  {
    if (options.opt[i] == 'R') /* reverse any bits? */
    {
      byte=reverseBits(byte, char2int(options.arg[i][0][0]), char2int(options.arg[i][1][0]));
    }
    else if (options.opt[i] == 'i') /* invert any bits? */
    {
      byte=flipBit(byte, char2int(options.arg[i][0][0]));
    }
    else if (options.opt[i] == 'T') /* transpose any bits? */
    {
      byte=swapBits(byte, char2int(options.arg[i][0][0]), char2int(options.arg[i][1][0]));
    }
  }

  return byte;
}

/** Read a byte from a file **/
int read(FILE *file, uchar *byte)
{
  /* eventually we'll add code to this to read only pertinent pixel data of non-linear image formats */

  return fread(byte, sizeof(uchar), 1, file);
}

/** Output a byte to screen or to file **/
void write(uchar byte)
{
  char str[9];
  extern bool print_chars;
  extern FILE *ouT;
  extern int chartype;

  if (byte < 32 || byte > 126)
  {
    if (chartype == 1)
    {
      return;
    }else{ if (chartype == 2)
      byte=32;
    }
  }

  if (out == NULL)
  {
    if (print_chars==true)
    {
      printf("%c", byte);
    }else{
      byte2bits(byte, str);
      printf("%s,", str);
    }
  }else{
    fwrite(&byte, sizeof(uchar), 1, out);
  }

  return;
}

/** free variables and exit **/
void endProgram(int value)
{
  int opt_index=-1;
  bool messagesOn=TRUE;

  extern FILE *host, *payload, *out;
  extern OPTION options;

  if (host != NULL)
  {
    fclose(host);
    host=NULL;
  }

  if (payload != NULL)
  {
    fclose(payload);
    payload=NULL;
  }

  if (out != NULL)
  {
    fclose(out);
    out=NULL;
  }

  /* are we being asked to suppress messages? */
  opt_index=getOpt('m');
  if (opt_index != -1)
    messagesOn=FALSE;
  
  freeOpts();

  if (messagesOn)
  {
    printf("\n");
    switch (value)
    {
      case 1:
        printf("WARNING: Reached end of host file.\n");
        exit(0); /* operations completed */
        break;
      case 2:
        printf("ERROR: Error opening host file for read access.\n");
        break;
      case 3:
        printf("ERROR: Error opening host file for write access.\n");
        break;
      case 4:
        printf("ERROR: Error opening payload file for read access.\n");
        break;
      case 5:
        printf("ERROR: You must specify a payload file in write mode.\n");
        break;
      case 6:
        printf("ERROR: You must specify an operation mode.\n");
        break;
      case 7:
        printf("ERROR: Error opening output file for write access.\n");
        break;
      case 8:
        printf("ERROR: Valid integers are 1-8 only for option '-b'.\n");
        break;
      case 9:
        printf("ERROR: Option '-R' requires two integer arguments between 1 and 8, and the second must not be smaller than the first. Example: -R 3 7\n");
        break;
      case 10:
        printf("ERROR: Option '-i' requires one integer argument between 1 and 8. Example: -i 4\n");
        break;
      case 11:
        printf("ERROR: Option '-T' requires two integer arguments between 1 and 8. Example: -T 1 5\n");
        break;
      case 12:
        printf("ERROR: Option '-B' and/or '-t' require one positive integer argument greater than 0. Example: -B 150\n");
        break;
      case 13:
        printf("WARNING: Host tail or byte limit reached.\n");
        exit(0); /* operations completed */
        break;
      case 14:
        printf("WARNING: Payload byte limit reached.\n");
        exit(0); /* operations completed */
        break;
      case 15:
        printf("ERROR: Only one operation mode can be given.\n");
        break;
      case 16:
        printf("ERROR: Option '-c' is a read mode-only function.\n");
        break;
      case 17:
        printf("ERROR: Option '-C' is a read mode-only function.\n");
        break;
      case 18:
        printf("ERROR: Option '-x' is a read mode-only function.\n");
        break;
      case 19:
        printf("ERROR: Option '-y' is a read mode-only function.\n");
        break;
      case 20:
        printf("ERROR: Option '-k' is a read mode-only function.\n");
        break;
      case 21:
        printf("ERROR: Option '-S' is a read mode-only function.\n");
        break;
    }
    if (value != 0)
      printf("WARNING: No data has been output or written.\n"); /* operations NOT completed */
  }

  exit(value);
}
