/* string and integer manipulation functions */

#include <stdlib.h> /* for atoi() or malloc() */
#include <string.h> /* for strlen() or strcpy() or strcmp() */
#include <ctype.h>  /* for toupper() */

#include "./types.h"
#include "./strint.h"

/** converts integer up to 9 digits to a string, positive or negative. **/
void int2str(char *str, int num)
{
  uint over=10;
  int i=0,len=0;
  bool isNegative=FALSE;

  /* we need to figure out how many digits are in our number... */
  len=intlen(num);

  for (i=0; i < (len-2); i++) /* if the number is greater >= 100 */
    over*=10; /* 1 digits over is 10, 3 digits, 100, 4 ditis, 1000... */

  if (num < 0) /* is the number negative? */
  {
    isNegative=TRUE; /* remember that it's a negative number */
    num=-num; /* make the number positive */
    
  }
  
// for some reason this just doesn't work
//  /* make sure the string can hold that many numbers! */
//  if (strlen(str) <= len+isNegative) /* and a space for the null terminator and a negative sign too if neccessary */
//    str=realloc(&str, sizeof(char) * len);

  /* add a negative sign if neccssary, and initiate i for the for loop below */
  if (isNegative==TRUE)
  {
    str[0]='-';
    i=1; /* skip the negative sign */
  }else{
    i=0; /* start at zero :-) */
  }

  if (len == 1) /* the number is one digit. very easy. */
  {
    str[0]=int2char(num);
    str[1]='\0'; /* and we add a peso! */
  }else{
    for (/* i initializes above */; i < len; i++)
    {
      str[i] = int2char(num/over); /* get left num: devide to make num less than 10, subtract .5 so we dont round up ( 6-.5 roudned is 6, and 6.9 -.5 rounded is also 6 ) */
      num-=(over*(num/over)); /* get rid of the digit we already copied with our 'over' variable, */
      over=over/10; /* next integer position */
    }
  }
  str[len]='\0'; /* and we add a peso! */

  return;
}

/** return integer as char **/
uchar int2char(int num)
{
  /* only works with ASCII, as if that would ever be a problem, and I'm pretty sure this should work for machines with bytes larger than 8 bits */
  if (num < 0 || num > 9) return '0';
  return (num + 48);
}

/** return the length of an integer up to 9 digits **/
uint intlen(int num)
{
  bool neg=FALSE;
  uint len=0, i=0;

  if (num < 0) /* is the number negative? */
  {
    neg=TRUE; /* remember that it's a negative number */
    num=-num; /* make the number positive */
  }

  /* bet ya never saw one of these before! */
  for(i=10, len=1; num/i >= 1; i*=10, len++);

  if (neg == TRUE)
    num=-num; /* restore the number to negative */

  return len; /* return length of number */
}

/** string to uppercase */
void ucase(char *str)
{
  uint i, len;

  len=strlen(str);

  for (i=0; i < len; i++)
    str[i] = toupper(str[i]);

  return;
}

/* string to lowercase. */
void lcase(char *str)
{
  uint i, len;

  len=strlen(str);

  for (i=0; i < len; i++)
    str[i] = tolower(str[i]);

  return;
}

/* String Extract */
void mid(char *string, uint start, uint length, char *str0)
{
  uint i=0, len;

  len = strlen(str0);

// for some reason this just doesnt work
//  /* its gotta be big enough */
//  if (len < length)
//    str0=realloc(&str0, (sizeof(char) * (length-len))+1); /* resize it, and add one for a null char */

  for (i=0; i<length; i++)
  {
    if (i < start+length-1) /* subtract 1 because we include the first char in the string. abcde start 3, length 3 would be cde, abcde is length 5, but start+length would be 6 */
      str0[i] = string[i+start];
    else /* no more room for string, we copied all that we could! */
      break;
  }

  str0[i]='\0';

  return;
}

/* char to integer */
uint char2int(uchar byte)
{
  uchar str[2];

  str[0]=byte;
  str[1]='\0'; /* atoi() accepts only strings */

  return atoi((char*)str);

// old method
//  if (byte >= 48 && byte <= 57)
//    return (byte - 48);
//  else
//    return 0; /* what else can we do? */
//
//  return 0; /* will never get here, but just because it feels wrong not to put a return at the end of a function :-) */
}
